#!/usr/bin/php

<?php

// Copyright (C) 2007 Cygnus <cygnus2 at post.cz>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA

define ("CFAIL","\033[1;31;40m !\033[0m ");
define ("COK","\033[1;32;40m *\033[0m ");
define ("CWARN","\033[1;33;40m ?\033[0m ");
define ("CTRY","\033[1;34;40m -\033[0m ");

define ("CRED","\033[1;31;40m");
define ("CGRN","\033[1;32;40m");
define ("CYELL","\033[1;33;40m");
define ("CBLUE","\033[1;34;40m");
define ("CMAGN","\033[1;35;40m");
define ("CCYAN","\033[1;36;40m");
define ("CWHITE","\033[1;37;40m");

define ("CDEF","\033[0m");

// configuration
//$cfg_infile		= './cyrillic.jhf';
//$cfg_infile		= './rowmans.jhf';	// filename of input file
//$cfg_infile		= './rowmant.jhf';	// filename of input file
//$cfg_infile		= './scripts.jhf';	// filename of input file
//$cfg_infile		= './scriptc.jhf';	// filename of input file
$cfg_infile		= './gothicger.jhf';	// filename of input file
//$cfg_infile		= './gothiceng.jhf';	// filename of input file
$cfg_step		= 10;			// hpgl units per one step of hershey raster
$cfg_charw		= 25;			// character width (nonproportional printing)
//$cfg_penwidth		= 2;			// pixel will be smaller by this amount of hpgl units

$debug = 0;

// 6450x9000 are limits of my plotter - replica Alfi, ot has 816x860dpi
$cfg_xlimit		= 6450;			// width of drawable arrea
$cfg_ylimit		= 9000;			// height of drawable arrea

$cfg_leftmargin		= 300;			// zero margin will not work, hershey fonts have coordinates < 0
$cfg_rightmargin	= 400;
$cfg_toplmargin		= 300;
$cfg_bottommargin	= 300;

// --------------------------------------------------------------------------------------

function convert_font_to_hpgl ($infile)
{
	global $debug;
	
	global $cfg_step;
	global $cfg_penwidth;
	global $cfg_charw;
	
	global $cfg_xlimit;
	global $cfg_ylimit;
	
	global $cfg_leftmargin;
	global $cfg_rightmargin;
	global $cfg_topmargin;
	global $cfg_bottommargin;
	
	// init sequence
	echo "IN;SP1;PU0,0;";
	
	$znakx = $cfg_leftmargin;
	$znaky = $cfg_bottommargin;

	$pen = 0;		// pen status 0 = up, 1 = down

	// read line by line
	
	$min_width = 0;
	$min_height = 0;
	$max_width = 0;
	$max_height = 0;
	
	$char = 32;
	
	while (($line = fgets($infile)) !== false) 
	{
		echo "\n";
		
		$length = strlen($line);
		if ($length > 8)
		{
			$glyph_number = 0;
			
			for ($n = 0; $n < 5; $n++)
			{
				if (($line[$n] >= '0') && ($line[$n] <= '9'))
				{
					$glyph_number = $glyph_number * 10;
					$glyph_number += ($line[$n] - '0');
				}
			}
			if ($debug == '1')
			{
				echo CRED."glyph ";
				if ($glyph_number < 10) echo " ";
				if ($glyph_number < 100) echo " ";
				if ($glyph_number < 1000) echo " ";
				echo CYELL.$glyph_number." ".CDEF;
				if ($char < 10) echo " ";
				if ($char < 100) echo " ";
				echo CGRN.$char.CDEF." \t";
			}
			
			$pairs = 0;
			
			for ($n = 6; $n < 8; $n++)
			{
				if (($line[$n] >= '0') && ($line[$n] <= '9'))
				{
					$pairs = $pairs * 10;
					$pairs += ($line[$n] - '0');
				}
			}
			if ($debug == '1')
			{
				echo "pairs ";
				if ($pairs < 10) echo " ";
				echo CYELL.$pairs.CDEF."\t";
			}
			
			for ($n = 0; $n < $pairs; $n++)
			{
				if ($debug == '1') echo ($line[8+2*$n].$line[9+2*$n])." ";
			}
			if ($debug == '1') echo "\n";
			
			$xmax = 0;
			$ymax = 0;
			$xmin = 0;
			$ymin = 0;
			
			for ($n = 0; $n < $pairs; $n++)
			{
				if (($n == 0) && ($debug == '1'))
				{
					$x = (ord ('R') - ord ($line[8+2*$n]));
					$y = -(ord ('R') - ord ($line[9+2*$n]));
					
					echo "first pair ".CYELL.$x.",".$y.CDEF."\n";
				}

				if ($n > 0)
				{
					// first coordinates are ... for what? for positioning of glyph?
					if (($line[8+2*$n] == ' ') && ($line[9+2*$n] == 'R'))
					{
						echo "PU;";
						$pen = 0;
					} else {
						$x = -(ord ('R') - ord ($line[8+2*$n]));
						$y = ord ('R') - ord ($line[9+2*$n]);
						
						if ($x > $xmax) $xmax = $x;
						if ($x < $xmin) $xmin = $x;
						if ($y > $ymax) $ymax = $y;
						if ($y < $ymin) $ymin = $y;
						
						if ($pen == 0)
							echo "PU";
						else
							echo "PD";
						
						echo ($znakx+$x*$cfg_step).",".($znaky+$y*$cfg_step).";";
						
						if ($pen == 0) echo "PD;";
						$pen = 1;
					}
				}
			}
			echo "PU;\n";
			$pen = 0;
			
			if ($debug == '1')
			{
				echo "min ".CYELL.$xmin.",".$ymin.CDEF."\t";
				echo "max ".CYELL.$xmax.",".$ymax.CDEF."\t";
				echo "height ".CYELL.($ymax - $ymin).CDEF."\t";
				echo "width ".CYELL.($xmax - $xmin).CDEF."\n";
			}
			
			if (($xmax - $xmin) < $min_width) $min_width = $xmax - $xmin;
			if (($xmax - $xmin) > $max_width) $max_width = $xmax - $xmin;
			
			if (($ymax - $ymin) < $min_height) $min_height = $ymax - $ymin;
			if (($ymax - $ymin) > $max_height) $max_height = $ymax - $ymin;
	
			if (($znakx + $cfg_charw * $cfg_step) < ($cfg_xlimit - $cfg_rightmargin))
			{
				$znakx = $znakx + $cfg_charw * $cfg_step;
			} else {
				$znakx = $cfg_leftmargin;
				$znaky = $znaky + 40 * $cfg_step;
			}
			
			$char++;
		}
	}
	if ($debug == '1')
	{
		echo "min height ".CYELL.$min_height.CDEF."\t";
		echo "max height ".CYELL.$max_height.CDEF."\n";
		echo "min width ".CYELL.$min_width.CDEF."\t";
		echo "max width ".CYELL.$max_width.CDEF."\n";
	}
	echo "PU0,0;SP0;IN;";
}

// --------------------------------------------------------------------------------------

if (file_exists ($cfg_infile))
{
	$infile = fopen ($cfg_infile, "r");

	if ($infile)
	{
		convert_font_to_hpgl ($infile);
		
		for ($n = 1; $n < 10; $n++) echo "        \n";
		
		if ($infile) fclose ($infile);
	}
	else
		if (!$infile) echo CFAIL."Opening file \"$cfg_infile\" failed.\n".CDEF;
}
else
	if (!$infile) echo CFAIL."File \"$cfg_infile\" does not exists.\n".CDEF;

return (0);

?>
